#define _GNU_SOURCE

#include <stdio.h>
#include <sys/time.h>
#include <errno.h>
#include <signal.h>

static void
handler(int sig)
{
}

int
main(int argc, char *argv[])
{
	int ret, sec, err;
	struct timespec ts, rem;

	/*
	 * usage: repro [SLEEP_SECONDS]
	 */

	if (argc >= 2)
		sec = atoi(argv[1]);
	if (sec <= 0)
		sec = 10;

	/*
	 * Install a signal handler so we can demonstrate that we do get the
	 * expected behavior upon receipt of a signal that is handled.
	 */

	signal(SIGALRM, handler);

	ts.tv_sec = sec;
	ts.tv_nsec = 0;

	printf("nanosleep(%ld,%ld)\n", ts.tv_sec, ts.tv_nsec);

	ret = nanosleep(&ts, &rem);

	/*
	 * When the nanosleep is interrupted by another process
	 * PTRACE_{ATTACH|DETACH}-ing us, we see errno == EINVAL
	 * rather than the expected EINTR.
	 */

	if (ret == -1)
	{
		err = errno;

		if (err == EINTR)
			printf("PASS: EINTR\n");
		else if (err == EINVAL)
			printf("FAIL: EINVAL\n");
		else
			printf("FAIL: errno %d\n", err);
	}
	else
	{
		printf("PASS: ret=%d\n", ret);
	}

	exit(ret == 0 || err == EINTR);
}
